<?php
$folder = JPATH_ROOT.'/administrator/components/com_starryscashbox/starrysapi/';
require_once($folder.'client.php');
require_once($folder.'command.php');
require_once($folder.'devicestatus.php');
require_once($folder.'documenttype.php');
require_once($folder.'helper.php');
require_once($folder.'noncashtype.php');
require_once($folder.'payattribute.php');
require_once($folder.'taxid.php');

class StarrysCashboxHelper{
	static function writeLog($type, $data) {
		JLog::addLogger(
		   array(
				'text_file' => 'checkonline.log.php'
		   ),
		   JLog::ALL,
		   array('plg_checkoline')
	   );

		JLog::add("$type:\n".var_export($data, true), JLog::INFO, 'plg_checkoline');
	}

	static function getCheckId($order_number, $type = 0) {
		$db = JFactory::getDBO();
		$db->setQuery("SELECT id FROM #__starryscashbox_receipt where order_number=".$db->Quote($order_number)." and type=".$db->Quote($type));
		$result = $db->loadObject();
		if($result){
			return strval($result->id);
		} else {
			$db->setquery("INSERT INTO #__starryscashbox_receipt (order_number, type, status, date) values (".$db->quote($order_number).",".$db->quote($type).",0,NOW())");
			$db->query();
			return strval($db->insertId());
		}
	}

	static function initApi() {
		$componentParams = JComponentHelper::getParams( 'com_starryscashbox' );
		$db = JFactory::getDBO();
		$query = $db->getQuery(true);

		$query->select($db->quoteName(array( 'manifest_cache')))
				->from($db->quoteName('#__extensions'))
				->where('element="pkg_starryscashbox"');

		$db->setQuery($query);

		$result = $db->loadObject();
		$info = json_decode($result->manifest_cache);

		$api = new Starrys\Cashbox\Api\Client($componentParams->get('endpoint'), $componentParams->get('group'), 'auto');

		$api->setCmsId('Joomla', $info->version);
		$api->setClientId($componentParams->get('client_id'));
		$api->setPasswords($componentParams->get('cashier_password'));

		if ($componentParams->get('cert')) {
			$api->setCertificate($componentParams->get('cert'), $componentParams->get('key'), $componentParams->get('cert_password'));
		}
		return $api;
	}
}