<?php
// No direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.view');
if(version_compare(JVERSION,'3.0.0','ge')) {
	class StarrysCashboxProxyView extends JViewLegacy{}
} else {
	class StarrysCashboxProxyView extends JView{}
}

class StarrysCashboxViewStarrysCashbox extends StarrysCashboxProxyView
{

	/**
	 * An array of items
	 *
	 * @var  array
	 */
	protected $items;

	/**
	 * The pagination object
	 *
	 * @var  JPagination
	 */
	protected $pagination;

	/**
	 * The model state
	 *
	 * @var  object
	 */
	protected $state;


	/**
	 * Display the view
	 */
	public function display($tpl = null)
	{
		$this->state         = $this->get('State');
		$this->items         = $this->get('Items');
		$this->pagination    = $this->get('Pagination');
		$canDo = self::getActions();
		// Check for errors.
		if (count($errors = $this->get('Errors')))
		{
			JError::raiseError(500, implode("\n", $errors));

			return false;
		}
		if ($canDo->get('core.admin') || $canDo->get('core.options'))
		{
			JToolBarHelper::preferences('com_starryscashbox');
		}
		JToolBarHelper::custom( 'gotoplugins','options','options','Плагины');
		JToolBarHelper::title(JText::_('COM_STARRYSCASHBOX_SETTINGS'));
		parent::display($tpl);
	}


	private static function getActions()
	{
		if(class_exists('JHelperContent')){
			return JHelperContent::getActions('com_starryscashbox');
		} else {
			$user	= JFactory::getUser();
			$result	= new JObject;
			$assetName = 'com_starryscashbox';

			$actions = JAccess::getActions('com_starryscashbox');

			foreach ($actions as $action) {
				$result->set($action->name,	$user->authorise($action->name, $assetName));
			}

			return $result;
		}
	}

}
