<?php

if (!defined('_VALID_MOS') && !defined('_JEXEC'))
    die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

if (!class_exists('vmPSPlugin'))
    require(JPATH_VM_PLUGINS .  '/vmpsplugin.php');
$folder = JPATH_ROOT.'/administrator/components/com_starryscashbox/starrysapi/';
require_once($folder.'client.php');
require_once($folder.'command.php');
require_once($folder.'devicestatus.php');
require_once($folder.'documenttype.php');
require_once($folder.'helper.php');
require_once($folder.'noncashtype.php');
require_once($folder.'payattribute.php');
require_once($folder.'taxid.php');
require_once($folder.'productlist.php');
require_once(JPATH_ROOT.'/administrator/components/com_starryscashbox/helper/helper.php');

class plgVmPaymentStarrysCashbox extends vmPSPlugin {

    // instance of class
    public static $_this = false;

    function __construct(& $subject, $config) {
		parent::__construct($subject, $config);

	    $this->tableFields = array_keys($this->getTableSQLFields());
		$varsToPush = $this->getVarsToPush ();
	    $this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
    }

    protected function getVmPluginCreateTableSQL() {
	return $this->createTableSQL('starrystable');
    }

    function getTableSQLFields() {
	$SQLfields = array(
	);

	return $SQLfields;
    }

    function plgVmConfirmedOrder($cart, $order) {

		return null;

    }

    function plgVmOnUpdateOrderPayment($data,$old_status){
        if (!class_exists('VirtueMartModelOrders'))
                require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
            $orderModel = VmModel::getModel('orders');
            $order = $orderModel->getOrder($data->virtuemart_order_id);
            $componentParams = JComponentHelper::getParams( 'com_starryscashbox' );
            $db = JFactory::getDBO();
            if(
                in_array($order['details']['BT']->virtuemart_paymentmethod_id, $this->params->get('paymentmethod'))
                && (
                    in_array($data->order_status, $this->params->get('status'))
                    || in_array($data->order_status, $this->params->get('status_return'))
                    )
                )
            {
                if (in_array($data->order_status, $this->params->get('status'))){
                    $type = 0;
                } else {
                    $type = 1;
                }

                $contact = $order['details']['BT']->email;
                $i = 0;
                $total_sum = 0;
                $discount = $order['details']['BT']->coupon_discount + $order['details']['BT']->order_payment ;
                $shipping = $order['details']['BT']->order_shipment + $order['details']['BT']->order_shipment_tax;
                if($discount) {
                    $discount = $discount/($order['details']['BT']->order_salesPrice + $shipping);
                }

                if ($type == 0) {
                    $documentType = Starrys\Cashbox\Api\DocumentType::DEBIT;
                } else {
                    $documentType = Starrys\Cashbox\Api\DocumentType::REFUND_DEBIT;
                }

                $checkId = StarrysCashboxHelper::getCheckId($order['details']['BT']->order_number, $type);
                $requestData = array(
                        'RequestId'             => $checkId,
                        'Password'              => intval($componentParams->get('cashier_password')),
                        'PhoneOrEmail'          => $contact,
                        'Group'                 => $componentParams->get('group'),
                        'FullResponse'          => false,
                        'Cash'                  => 0,
                        'Device'                => 'auto',
                        'NonCash'               => array(0, round($order['details']['BT']->order_total*100), 0),
                        'MaxDocumentsInTurn'    => intval($componentParams->get('docs_in_turn')),
                        'TaxMode'               => pow(2, $componentParams->get('tax_mode')),
                        'DocumentType'          => $documentType,
                        'Lines'                 => array()
                    );
                if($componentParams->get('client_id')) {
                    $requestData['ClientId'] = $componentParams->get('client_id');
                }

                $productvat = intval($componentParams->get('product_vat'));
                $nds = $this->params->get('nds');
                $lines = new Starrys\Cashbox\Api\ProductList($order['details']['BT']->order_total);
                foreach($order['items'] as $product) {
                    if($productvat) {
                        $vat = $productvat;
                    } else {
                        $db->setQuery("SELECT product_tax_id FROM #__virtuemart_product_prices WHERE virtuemart_shoppergroup_id=0 and virtuemart_product_id=".$product->virtuemart_product_id);
                        $tax_id = $db->loadResult();
                        $vat = $nds->$tax_id;
                    }
                    $lines->addItem($product->order_item_name, $product->product_final_price, $vat, $product->product_quantity);
                }
                if ($order['details']['BT']->order_shipment) {
                    $delivery_vat = $componentParams->get('delivery_vat');
                    if(!$delivery_vat) {
                        $db->setQuery("SELECT shipment_params FROM #__virtuemart_shipmentmethods WHERE virtuemart_shipmentmethod_id=".$order['details']['BT']->virtuemart_shipmentmethod_id);
                        $shipment_params = $db->loadResult();
                        preg_match('#tax_id="(\d+)"#', $shipment_params, $match);
                        $tax_id = $match[1];
                        $delivery_vat = $nds->$tax_id;
                    }
                    $lines->addItem("Доставка", $shipping, $delivery_vat);
                }

                $requestData['Lines'] = $lines->getItems();

                $api  = StarrysCashboxHelper::initApi();

                $result = $api->sendRequest('Complex', $requestData);
                if($componentParams->get('log')) {
                    StarrysCashboxHelper::writeLog('request', $api);
                    StarrysCashboxHelper::writeLog('response', $result);
                }
                if($result && $result->response && $result->response->Response) {
                    if($result->response->Response->Error == 0) {
                        $db->setQuery("update #__starryscashbox_receipt set status=1 where id=".$checkId);
                        $db->query();
                    } else {
                        StarrysCashboxHelper::writeLog('error', $result);
                    }
                }

            }
		return null;
	}


    /**
     * Display stored payment data for an order
     *
     */
    function plgVmOnShowOrderBEPayment($virtuemart_order_id, $virtuemart_payment_id) {
    	return null;
    }

    function getCosts(VirtueMartCart $cart, $method, $cart_prices) {
		return false;
    }

    protected function checkConditions($cart, $method, $cart_prices) {

		return false;
    }


    function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {
	return $this->onStoreInstallPluginTable($jplugin_id);
    }

    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
	return $this->OnSelectCheck($cart);
    }

    function plgVmDeclarePluginParamsPaymentVM3( &$data) {
		return $this->declarePluginParams('payment', $data);
	}

    public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
	return $this->displayListFE($cart, $selected, $htmlIn);
    }


    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
	return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }

    function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId) {

	if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
	    return null; // Another method was selected, do nothing
	}
	if (!$this->selectedThisElement($method->payment_element)) {
	    return false;
	}
	 $this->getPaymentCurrency($method);

	$paymentCurrencyId = $method->payment_currency;
    }

    function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array()) {
	return $this->onCheckAutomaticSelected($cart, $cart_prices);
    }

    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
		return null;
    }

    function plgVmonShowOrderPrintPayment($order_number, $method_id) {
	return $this->onShowOrderPrint($order_number, $method_id);
    }

    function plgVmDeclarePluginParamsPayment($name, $id, &$data) {
	return $this->declarePluginParams('payment', $name, $id, $data);
    }

    function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {
	return $this->setOnTablePluginParams($name, $id, $table);
    }


    public function plgVmOnPaymentNotification() {
		return null;
    }

    function plgVmOnPaymentResponseReceived(  &$html) {
		return null;
    }

    function plgVmOnUserPaymentCancel() {
		return null;
    }
}

// No closing tag
