<?php

defined('_JEXEC') or die;

$folder = JPATH_ROOT.'/administrator/components/com_starryscashbox/starrysapi/';
require_once($folder.'client.php');
require_once($folder.'command.php');
require_once($folder.'devicestatus.php');
require_once($folder.'documenttype.php');
require_once($folder.'helper.php');
require_once($folder.'noncashtype.php');
require_once($folder.'payattribute.php');
require_once($folder.'taxid.php');
require_once($folder.'productlist.php');
require_once(JPATH_ROOT.'/administrator/components/com_starryscashbox/helper/helper.php');

class plgJshoppingorderStarrysCashbox extends JPlugin
{
	function __construct(& $subject, $config) {

		parent::__construct($subject, $config);
	}

	public function onAfterChangeOrderStatus($order_id, $status, $message){
		$order = JTable::getInstance('order', 'jshop');
		$order->load($order_id);
		$this->onOrderUpdate($order);
		return true;
	}
	public function onAfterChangeOrderStatusAdmin($order_id, $order_status, $status_id, $notify, $comments, $include, $view_order){
		$order = JTable::getInstance('order', 'jshop');
		$order->load($order_id);
		$this->onOrderUpdate($order);
		return true;
	}


	public function onAfterCreateOrder($order){
		$this->onOrderUpdate($order);
		return true;
	}

	private function onOrderUpdate($order){
		$componentParams = JComponentHelper::getParams( 'com_starryscashbox' );
		$order->getAllItems();

		if(
			in_array($order->payment_method_id, $this->params->get('paymentmethod'))
			&& (
				in_array($order->order_status, $this->params->get('status'))
				|| in_array($order->order_status, $this->params->get('status_return'))
				)
			)
		{
			if (in_array($order->order_status, $this->params->get('status'))){
				$type = 0;
			} else {
				$type = 1;
			}

			if ($type == 0) {
				$documentType = Starrys\Cashbox\Api\DocumentType::DEBIT;
			} else {
				$documentType = Starrys\Cashbox\Api\DocumentType::REFUND_DEBIT;
			}

			$checkId = StarrysCashboxHelper::getCheckId($order->order_number, $type);

			$requestData = array(
					'RequestId'             => $checkId,
					'Password'              => intval($componentParams->get('cashier_password')),
					'PhoneOrEmail'          => $order->email,
					'Group'                 => $componentParams->get('group'),
					'FullResponse'          => false,
					'Cash'                  => 0,
					'Device'                => 'auto',
					'NonCash'               => array(0, round($order->order_total*100), 0),
					'MaxDocumentsInTurn'    => intval($componentParams->get('docs_in_turn')),
					'TaxMode'               => pow(2, $componentParams->get('tax_mode')),
					'DocumentType'			=> $documentType,
					'Lines'                 => array()
				);
			if($componentParams->get('client_id')) {
				$requestData['ClientId'] = $componentParams->get('client_id');
			}
			$product_vat = intval($componentParams->get('product_vat'));

			$discount = $order->order_payment - $order->order_discount;
			$shipping = $order->order_shipping;
			if($discount) {
				$discount = $discount/($order->order_subtotal + $order->order_shipping);
			}

			$total_sum = 0;
			$iterator = 0;
			$lines = new  Starrys\Cashbox\Api\ProductList($order->order_total);
			$db = JFactory::getDBO();
			$nds = $this->params->get('nds');
			foreach($order->items as $item) {
				if(!$product_vat) {
					$db->setQuery("SELECT product_tax_id FROM #__jshopping_products WHERE product_id=".$item->product_id);
					$tax_id = $db->loadResult();
					$vat = $nds->$tax_id;
				} else {
					$vat = $product_vat;
				}
				$lines->addItem($item->product_name, $item->product_item_price, $vat, $item->product_quantity);
			}

			if ($shipping > 0) {
				$lines->addItem("Доставка", $shipping, $componentParams->get('delivery_vat'));
			}

			$requestData['Lines'] = $lines->getItems();

			$api  = StarrysCashboxHelper::initApi();

			$result = $api->sendRequest('Complex', $requestData);
			if($componentParams->get('log')) {
				StarrysCashboxHelper::writeLog('request', $api);
				StarrysCashboxHelper::writeLog('response', $result);
			}
			if($result && $result->response && $result->response->Response) {
				if($result->response->Response->Error == 0) {
					$db = JFactory::getDBO();
					$db->setQuery("update #__starryscashbox_receipt set status=1 where id=".$checkId);
					$db->query();
				} else {
					StarrysCashboxHelper::writeLog('error', $result);
				}
			}
		}
	}


}
