<?php
defined('_JEXEC') or die('Restricted access');
$folder = JPATH_ROOT.'/administrator/components/com_starryscashbox/starrysapi/';
require_once($folder.'client.php');
require_once($folder.'command.php');
require_once($folder.'devicestatus.php');
require_once($folder.'documenttype.php');
require_once($folder.'helper.php');
require_once($folder.'noncashtype.php');
require_once($folder.'payattribute.php');
require_once($folder.'taxid.php');
require_once($folder.'productlist.php');
require_once(JPATH_ROOT.'/administrator/components/com_starryscashbox/helper/helper.php');
?><?php
class plgHikashopStarrysCashbox extends JPlugin
{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('hikashop', 'starryscashbox');
			if(version_compare(JVERSION,'2.5','<')){
				jimport('joomla.html.parameter');
				$this->params = new JParameter($plugin->params);
			} else {
				$this->params = new JRegistry($plugin->params);
			}
		}
	}


	function onAfterOrderUpdate(&$order,&$send_email){
		if(!empty($order->order_id)){
			$class = hikashop_get('class.order');
			$componentParams = JComponentHelper::getParams( 'com_starryscashbox' );

			if(empty($order->order_status)){

				$old = $class->get($order->order_id);
				$order->order_status = $old->order_status;
			}

			if(
				in_array($order->old->order_payment_id, $this->params->get('paymentmethod'))
				&& (
					in_array($order->order_status, $this->params->get('status'))
					|| in_array($order->order_status, $this->params->get('status_return'))
					)
				)
			{
				if (in_array($order->order_status, $this->params->get('status'))){
					$type = 0;
				} else {
					$type = 1;
				}

				$class->loadProducts($order);
				$db = JFactory::getDBO();
				$db->setQuery("SELECT user_email FROM #__hikashop_user WHERE user_id=".$order->old->order_user_id);
				$email = $db->loadResult();

				if ($type == 0) {
					$documentType = Starrys\Cashbox\Api\DocumentType::DEBIT;
				} else {
					$documentType = Starrys\Cashbox\Api\DocumentType::REFUND_DEBIT;
				}

				$checkId = StarrysCashboxHelper::getCheckId($order->old->order_number, $type);

				$requestData = array(
						'RequestId'             => $checkId,
						'Password'              => intval($componentParams->get('cashier_password')),
						'PhoneOrEmail'          => $email,
						'Group'                 => $componentParams->get('group'),
						'FullResponse'          => false,
						'Cash'                  => 0,
						'Device'                => 'auto',
						'NonCash'               => array(0, round($order->old->order_full_price*100), 0),
						'MaxDocumentsInTurn'    => intval($componentParams->get('docs_in_turn')),
						'TaxMode'               => pow(2, $componentParams->get('tax_mode')),
						'DocumentType'			=> $documentType,
						'Lines'                 => array()
					);
				if($componentParams->get('client_id')) {
					$requestData['ClientId'] = $componentParams->get('client_id');
				}

				$discount = $order->old->order_discount_price + $order->old->order_discount_tax;
				$shipping = $order->old->order_shipping_price + $order->old->order_shipping_tax;
				if($discount) {
					$discount = $discount/$order->old->order_subtotal;
				}

				$total_sum = 0;
				$iterator  = 0;
				$lines = new Starrys\Cashbox\Api\ProductList($order->old->order_full_price);
				$product_vat = intval($componentParams->get('product_vat'));
				$nds = $this->params->get('nds');
				foreach($order->products as $item) {

					if($product_vat) {
						$vat = $product_vat;
					} else {
						$db->setQuery("SELECT product_tax_id FROM #__hikashop_product WHERE product_id=".$item->product_id);
						$tax_id = $db->loadResult();
						$vat = $nds->$tax_id;
					}
					$lines->addItem($item->order_product_name, $order->old->order_full_price, $vat, $item->order_product_quantity);
				}

				if ($shipping > 0) {
					$delivery_vat = $componentParams->get('delivery_vat');
					if(!$delivery_vat) {
						$db->setQuery("SELECT shipping_tax_id FROM #__hikashop_shipping WHERE shipping_id=".$order->old->order_shipping_id);
						$tax_id = $db->loadResult();
						$delivery_vat = $nds->$tax_id;
					}
					$lines->addItem('Доставка', $shipping, $delivery_vat);
				}

				$requestData['Lines'] = $lines->getItems();

				$api  = StarrysCashboxHelper::initApi();

				$result = $api->sendRequest('Complex', $requestData);
				if($componentParams->get('log')) {
					StarrysCashboxHelper::writeLog('request', $api);
					StarrysCashboxHelper::writeLog('response', $result);
				}
				if($result && $result->response && $result->response->Response) {
					if($result->response->Response->Error == 0) {
						$db->setQuery("update #__starryscashbox_receipt set status=1 where id=".$checkId);
						$db->query();
					} else {
						StarrysCashboxHelper::writeLog('error', $result);
					}
				}
			}
		}
		return true;
	}

}
